package rs2Gprs;

/*import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;*/

import javax.microedition.midlet.MIDlet;
import javax.microedition.midlet.MIDletStateChangeException;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;


public class Main extends MIDlet {

	public static final boolean DebugInfoToCOM = false; //_DEBUG
	
	ATCommand		atCommand; //       .
	Tc65SerialPort	tc65SerialPort;
	Io		io;
	MenuSettings	menuSetting;
	Tc65SocketConnection socketConnection;
	/**
	 * 
	 */
	public Main() {
		try
		{
			tc65SerialPort = new Tc65SerialPort();
			serialOut("\n\rStarting rs2gprs app...\n\r" + 
					"(build 101227" +
//					", Siemens R2 SDK)\n\r" +
//					", Siemens R3 SDK)\n\r" +
					", Cinterion R1 SDK)\n\r" +
					")\n\r" );

			atCommand = new ATCommand(false);

			io = new Io();
			
			menuSetting = new MenuSettings(tc65SerialPort, atCommand, io);

			// socketConnection  
			menuSetting.start();
			
		}
		catch(Exception e) 
		{
			System.out.println(e);
			notifyDestroyed();
		}
	}

	protected void destroyApp(boolean arg0) throws MIDletStateChangeException {
		System.out.println("destroyApp(" + arg0 + ")");

        notifyDestroyed();    

	}

	protected void pauseApp() {

	}
	/**
	 * Wrappers for debug output to serial port
	 * @param str
	 */
	void serialOut(String str)
	{
		tc65SerialPort.serialOut(str.getBytes());
	}
	void serialOut(byte[] ar)
	{
		tc65SerialPort.serialOut(ar);
	}
	void DebugOut(String str)
	{
		if(menuSetting.DebugInfoToCOM)
			tc65SerialPort.serialOut(str.getBytes());
	}
	void DebugOut(byte[] ar)
	{
		if(menuSetting.DebugInfoToCOM)
			tc65SerialPort.serialOut(ar);
	}


	protected void startApp() throws MIDletStateChangeException {
		// ,    
		io.Out(0, false);
		
		// ,   
		do
		{
        	try
        	{
        	Thread.sleep(1000);
        	}
        	catch(Exception e)
        	{
        		serialOut(e.toString());
        	}
		}
		while(menuSetting.isAlive());

		// ,         
		//  -    .    -       
		//  .
 		DebugOut("Menu finished, continuing\n\r");
 		DebugOut("***************************************************\n\r" +
 				 "*             ATTENTION!!!                        *\n\r" +
 				 "* Debug output is ON. It means you will NOT get   *\n\r" +
 				 "* correct data exchange with your device.         *\n\r" +
 				 "* PLEASE TURN DEBUGGING OFF TO WORK WITH HARDWARE *\n\r" +
 				 "***************************************************\n\r" 
 				);
		
		if(menuSetting.RetCode == menuSetting.MS_EXITPROG)
		{
			DebugOut("Exiting program...\r\n");
			destroyApp(true);
		}
			
		if(menuSetting.PinWasEntered == false)
		{
			//  PIN.   - .
			if(EnterPIN() == false)
			{
				DebugOut("Error entering PIN, exiting app...\n\r");
		        destroyApp(true);
			}
		}
		serialOut("\n\rSetting serial port baudrate to " + Integer.toString(menuSetting.BaudRate) + "\n\r" );
		//  -   
		tc65SerialPort.SetBaudRate(menuSetting.BaudRate);
		
		socketConnection = new Tc65SocketConnection(tc65SerialPort);
		
		byte ar[] = new byte[2048]; //    
		int pos = 0; //   

//		     ,     -  .
		//    .
		byte arFromSocket[] = new byte[256];  
		int posFromSocketR = 0; 
		int posFromSocketW = 0; 
		
		boolean bExit = false;
		int IncomingDataTimer = 0; //      .
		int IncomingKeepaliveTimer = 0; //     
		int KeepaliveCount = 0;
		
		// *************************************************************************
		// -     long,    ,  
		//    -!!!
		// **************************************************************************
		
        while(bExit == false)
        {
        	//    ,  
        	//      
        	try{atCommand.send("ATE1&C1&D0&S0X4Q0S0=1V1\r");}
    		catch(ATCommandFailedException e){}
        	
        	try
        	{
        	Thread.sleep(5000); // Datasheet says to reconnect after 600 s delay!
        	}
        	catch(Exception e)
        	{
        		DebugOut(e.toString());
        	}
        	
        	DebugOut("*g*");
        	
      		//  
       		SetupConnection();
	        		
    		// 
    		boolean bConnected = socketConnection.Connect();
    		//  ,   
    		if(bConnected == true)
    		{
       			io.Out(0, true);
               	DebugOut("*G*");
    		}
    		else
    		{
       			io.Out(0, false);
    			continue;
    		}
       		//    
   			IncomingDataTimer = millisNow(); //      .
   			IncomingKeepaliveTimer = IncomingDataTimer; //     
   			KeepaliveCount = IncomingDataTimer;
   			boolean bPreviousByteWasFF = false; //     
   			
       		while(socketConnection.IsConnected())
       		{
       			boolean Stop = false;
   				pos = 0;

   				// For Modbus delay support
   				boolean AllSerialDataGot = false;
   				int IncomingSerialDataTimer = millisNow(); // Track data addival time
   				
   				while(AllSerialDataGot == false)
   				{
	   				//   -     
					while(tc65SerialPort.hasData() > 0)
					{
						IncomingSerialDataTimer = millisNow();
						int j = tc65SerialPort.readByte();
						if(j != -1)
						{
							byte b = (byte)(j);
							ar[pos]=b;
							pos++;
	
							//  ff,  2 .
							if(j == menuSetting.KeepaliveByte && menuSetting.UseKeepalives == true)
							{
	    						ar[pos]=b;
	    						pos++;
	    						DebugOut("*FF*");
							}
	//            					socketConnection.writeByte(b);
						}
					}
					// If not using Modbus exit loop immediately.
					if(menuSetting.UseModbus == false)
						AllSerialDataGot = true;
					// If using Modbus exit loop on data not arriving.
					if((menuSetting.UseModbus == true && ((millisNow()-IncomingSerialDataTimer) > menuSetting.ModbusDelay)))
						AllSerialDataGot = true;
   				}
   				
				if(pos > 0)
				{
					socketConnection.write(ar, pos);
					KeepaliveCount = millisNow();
				}
	        				
				//  
				if(KeepaliveCount > 20000)  // 20 
				{
					KeepaliveCount = millisNow();
					if(menuSetting.UseKeepalives == true)
					{
						socketConnection.writeByte((byte)menuSetting.KeepaliveByte);
						DebugOut("*K*");
					}
				}
	        				
				//       ,  .  
				int len = socketConnection.hasData();
				
				if(len > 0)
				{
        			IncomingDataTimer = millisNow();
					DebugOut("*s"+Integer.toString(len)+"*");
				}

				while(len > 0)
				{
					int j = socketConnection.readByte();
					boolean bProceed = true;
					if(j<0)
						bProceed = false;
					else
						IncomingDataTimer = millisNow();

					// ,     0xYZ,    0xYZ, 
					//    0xYZYZ,   .
					
					if(j != menuSetting.KeepaliveByte) //   -  ff,   
					{
						bPreviousByteWasFF = false;
						IncomingKeepaliveTimer = millisNow();
					}
					
					if(menuSetting.UseKeepalives == true && j == menuSetting.KeepaliveByte)
					{
						//    FF    (> 5 c)?
						if(bPreviousByteWasFF == true && IncomingKeepaliveTimer > 5000)
						{
							// ,     FF
							bPreviousByteWasFF = true; //    .
							IncomingKeepaliveTimer = millisNow(); //  
							bProceed = false;
						}	        						
						//   -  FF?
						else if(bPreviousByteWasFF == false) 
						{
							// ,     FF
							bPreviousByteWasFF = true; // ,   FF
							IncomingKeepaliveTimer = millisNow(); //  
							bProceed = false; //  
						}
						else if(bPreviousByteWasFF == true && IncomingKeepaliveTimer <= 5000)
						{
							//     FF - ,     
							bPreviousByteWasFF = false; 
							bProceed = true;
						}
						
					}
					if(bProceed == true)
					{
						//     ,         
						//  .         !!!
						arFromSocket[posFromSocketW] = (byte)j;
						posFromSocketW++;
						if(posFromSocketW >= 256) posFromSocketW = 0;
					}

					// ,    -  .  -  .
					len = socketConnection.hasData();
				}

				// If Modbus delay not used or exceeded the value set in menu.
				if(
						(menuSetting.UseModbus == false) ||
						(menuSetting.UseModbus == true && (((millisNow())-IncomingDataTimer) > menuSetting.ModbusDelay))
						) // If no data arrived from socket for a long time
				{
					while(posFromSocketR != posFromSocketW)
					{
						byte b = arFromSocket[posFromSocketR];
						tc65SerialPort.writeByte(b);
						posFromSocketR++;
						if(posFromSocketR >= 256) posFromSocketR = 0;
						
			        	//  2 -  ...   65   2 -.
						// calculate delay to send out the byte on current baudrate:
						// 8 data + startbit + 2 stopbits + 1 guard bit for the case, *1000 ms 
						int br = menuSetting.BaudRate;
						if(br == 0) br = 1;
						int delay = (12000/menuSetting.BaudRate) + 1;
						if(delay > 50) delay = 50; if(delay < 1) delay = 1;

						if(menuSetting.BaudRate < 19200)
						{
							try
				        	{
				        	Thread.sleep(delay);
				        	}
				        	catch(Exception e)
				        	{
				        		DebugOut(e.toString());
				        	}
						}
					}
				}
				
//       -      .
//    ,     ( ) -
//      ! 

    			if((millisNow()-IncomingDataTimer) > 60000) // 60 
    			{
					DebugOut("*S("+Integer.toString(millisNow()-IncomingDataTimer)+")["+
							Integer.toString(millisNow()-IncomingKeepaliveTimer)+"]*");
    				Stop = true;
    			}
    			if(Stop == true)
    				break;
     		}
    		//   
    		socketConnection.Disconnect();
 
    		io.Out(0, false);
			DebugOut("*D*");
			
			//   ,      , 
			//   2 . ,   ?
			// TODO
        }
         
        //  ,     .
        
		//  -   115200
        serialOut("\n\rDestroying...\n\r");
        
		io.Out(0, false); // off

		destroyApp(true);
	}

	boolean EnterPIN()
	{
		boolean bOkFound = false;
		
		if(menuSetting.PINCode.length() == 0)
		{
			DebugOut("PIN empty, will not be sent.\n\r" );
			return true;
		}
		
		//     -    (  ).
		//      .
		char ar[] = menuSetting.PINCode.toCharArray();
		boolean bIsNotPin = false;
		for(int i=0; i<menuSetting.PINCode.length(); i++)
		{
			if(ar[i] < '0' || ar[i] > '9')
				bIsNotPin = true;
		}
		if(bIsNotPin == true)
		{
			DebugOut("PIN is " + menuSetting.PINCode + "(not a PIN), will not be sent.\n\r" );
			return true;
		}
		
		DebugOut("PIN=" + menuSetting.PINCode + "\r\n" );
		String s = new String("(no command has been sent)");
		try{
		s = atCommand.send("AT+CPIN=" + menuSetting.PINCode + "\r");
		}
		catch(ATCommandFailedException e)
		{
			serialOut("Exception " + e.getMessage() + "\n\r" );
		}
		DebugOut("\r\nCommand:" + s + "\n\r" );
		
		if(s.indexOf("OK") > 0)
			bOkFound = true;
		
		return bOkFound;
	}
	
	void SetupConnection()
	{
		socketConnection.SetConnType(/*bConnType*/io.CONN_TYPE_GPRS);

		socketConnection.setAPN(menuSetting.szAPN);
		socketConnection.setURL(menuSetting.szAddressToConnectTo);
		socketConnection.setPort(menuSetting.PortToConnectTo);

		socketConnection.setUsername(menuSetting.szUsername);
		socketConnection.setPassword(menuSetting.szPassword);
	}

	//         long,   .
	public int millisNow()
	{
		return (int)System.currentTimeMillis();
	}
}
