package rs2Gprs;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.microedition.io.Connector;
import javax.microedition.io.SocketConnection;

/**
 * @author -
 *
 */
public class Tc65SocketConnection {

	SocketConnection socketConn;
	InputStream   	inStream;
	OutputStream  	outStream;
	Tc65SerialPort  tc65SerialPort;
	
	//    
	boolean bUseGprs=true; //CSD / GPRS
	String szAPN;
	String szCSDPhoneNumber;
	String szUsername;
	String szPassword;
	String szConnectionString;
	String szURL;
	int Port;
	
	boolean bConnected;
	/**
	 * 
	 */
	public Tc65SocketConnection(Tc65SerialPort  tc65SerialPort) {
		this.tc65SerialPort = tc65SerialPort;
		szAPN = new String("internet.nw");
		szCSDPhoneNumber = new String("");
		szUsername = new String("");
		szPassword = new String("");
		szConnectionString = new String("");
		szURL = new String("www.gsmpager.ru");
		Port = 7265; // "tc65"
	}
	
	private void BuildConnectionString() {
		szConnectionString = "socket://" + szURL + ":" + 
			Integer.toString(Port) + ";bearer_type=";
		if(bUseGprs)
			szConnectionString += "gprs;access_point=" + szAPN;
		else
			szConnectionString += "csd;phone_number=" + szCSDPhoneNumber;
		if(szUsername.length() > 0)
			szConnectionString += ";username=" + szUsername + ";password=" + 
				szPassword;
		szConnectionString += ";timeout=30";
	}
	
	public boolean Connect()
	{
		bConnected = false;
		try
		{
			BuildConnectionString();
//			tc65SerialPort.serialOut("Connection string: " + szConnectionString + "\r\n");
			socketConn = (SocketConnection)Connector.open(szConnectionString);
			
//    - 5200.			
//			int v = socketConn.getSocketOption(SocketConnection.RCVBUF);
//			int vv = socketConn.getSocketOption(SocketConnection.SNDBUF);
//			tc65SerialPort.serialOut("RX=" + Integer.toString(v)+",TX="+Integer.toString(vv)+"\r\n");
			
			socketConn.setSocketOption(SocketConnection.LINGER, 5);
			socketConn.setSocketOption(SocketConnection.KEEPALIVE, 1);
			socketConn.setSocketOption(SocketConnection.DELAY, 1);
//			socketConn.setSocketOption(SocketConnection.RCVBUF, 1024);
//			socketConn.setSocketOption(SocketConnection.SNDBUF, 1024);

//			tc65SerialPort.serialOut("Connector.open\r\n");
			//socketConn.setSocketOption(SocketConnection.LINGER, 5);
			inStream = socketConn.openInputStream();
//			tc65SerialPort.serialOut("openInputStream\r\n");
			outStream = socketConn.openOutputStream();
//			tc65SerialPort.serialOut("openOutputStream\r\n");

			bConnected = true;
		}
		catch (IOException e) {
			tc65SerialPort.serialOut("IOException " + e.getMessage() + "\r\n");
			bConnected = false;
		}
		return bConnected;
	}

	public boolean IsConnected()
	{
		return bConnected;
	}
	
	public void Disconnect()
	{
		try
		{inStream.close();}
		catch(IOException ioe){}
		try
		{outStream.close();}
		catch(IOException ioe){}
		try
		{socketConn.close();}
		catch(IOException ioe){}
		bConnected = false;
	}
	
	public void SetConnType(boolean bUseGPRS)
	{
		this.bUseGprs = bUseGPRS;
	}

	public void setAPN(String szAPN) {
		this.szAPN = szAPN;
	}

	public void setURL(String szURL) {
		this.szURL = szURL;
	}

	public void setCSDPhoneNumber(String szCSDPhoneNumber) {
		this.szCSDPhoneNumber = szCSDPhoneNumber;
	}

	public void setUsername(String szUsername) {
		this.szUsername = szUsername;
	}

	public void setPassword(String szPassword) {
		this.szPassword = szPassword;
	}

	public void setPort(int port) {
		Port = port;
	}
	
	public int hasData()
	{
		int n = 0;
		try 
		{
			n = inStream.available();
		} 
		catch (IOException e) 
		{
			bConnected = false;
		}
		
		return n;
	}
	
	int readByte()
	{
		int NextByte = -1;
		try {
			NextByte = inStream.read();
		} catch (IOException e) {
			// TODO Auto-generated catch block
//			e.printStackTrace();
			tc65SerialPort.serialOut("readByte():IOException " + e.getMessage() + "\r\n");
			bConnected = false;
		}
		return NextByte;
	}

	boolean writeByte(byte b)
	{
		boolean bOk = false;
		try {
			outStream.write(b);
			bOk = true;
		} catch (IOException e) {
//			e.printStackTrace();
			bOk = false;
			tc65SerialPort.serialOut("writeByte():IOException " + e.getMessage() + "\r\n");
			bConnected = false;
		}
		return bOk;
	}
	
	int read(byte[] array, int len)
	{
		int nBytes = 0;
		if(len > array.length)
			len = array.length;
		try {
			nBytes = inStream.read(array, 0, len);
		} catch (IOException e) {
//			e.printStackTrace();
			tc65SerialPort.serialOut("read():IOException " + e.getMessage() + "\r\n");
			bConnected = false;
		}
		return nBytes;
	}
	boolean write(byte[] array, int len)
	{
		boolean bOk = false;
		try {
			outStream.write(array, 0, len);
			bOk = true;
		} catch (IOException e) {
			e.printStackTrace();
			bOk = false;

			tc65SerialPort.serialOut("write():IOException " + e.getMessage() + "\r\n");
			
			bConnected = false;
		}
		return bOk;
	}
	
}
